Whenever the page sends a request for a network resource the following sequence of events are emitted by Page:
If request fails at some point, then instead of 'requestfinished' event (and possibly instead of 'response' event), the page.on('requestfailed') event is emitted.
noteHTTP Error responses, such as 404 or 503, are still successful responses from HTTP standpoint, so request will complete with
'requestfinished'event.
If request gets a 'redirect' response, the request is successfully finished with the requestfinished event, and a new request is issued to a redirected url.
An object with all the request HTTP headers associated with this request. The header names are lower-cased.
Usage
await request.allHeaders();
Returns
The method returns null unless this request has failed, as reported by requestfailed event.
Usage
Example of logging of all the failed requests:
page.on('requestfailed', request => {
console.log(request.url() + ' ' + request.failure().errorText);
}); Returns
Returns the Frame that initiated this request.
Usage
const frameUrl = request.frame().url();
Returns
Details
Note that in some cases the frame is not available, and this method will throw.
request.serviceWorker() to check that.Here is an example that handles all the cases:
if (request.serviceWorker())
console.log(`request ${request.url()} from a service worker`);
else if (request.isNavigationRequest())
console.log(`request ${request.url()} is a navigation request`);
else
console.log(`request ${request.url()} from a frame ${request.frame().url()}`); Returns the value of the header matching the name. The name is case-insensitive.
Usage
await request.headerValue(name);
Arguments
name string
Name of the header.
Returns
An object with the request HTTP headers. The header names are lower-cased. Note that this method does not return security-related headers, including cookie-related ones. You can use request.allHeaders() for complete list of headers that include cookie information.
Usage
request.headers();
Returns
An array with all the request HTTP headers associated with this request. Unlike request.allHeaders(), header names are NOT lower-cased. Headers with multiple entries, such as Set-Cookie, appear in the array multiple times.
Usage
await request.headersArray();
Returns
Whether this request is driving frame's navigation.
Some navigation requests are issued before the corresponding frame is created, and therefore do not have request.frame() available.
Usage
request.isNavigationRequest();
Returns
Request's method (GET, POST, etc.)
Usage
request.method();
Returns
Request's post body, if any.
Usage
request.postData();
Returns
Request's post body in a binary form, if any.
Usage
request.postDataBuffer();
Returns
Returns parsed request's body for form-urlencoded and JSON as a fallback if any.
When the response is application/x-www-form-urlencoded then a key/value object of the values will be returned. Otherwise it will be parsed as JSON.
Usage
request.postDataJSON();
Returns
Request that was redirected by the server to this one, if any.
When the server responds with a redirect, Playwright creates a new Request object. The two requests are connected by redirectedFrom() and redirectedTo() methods. When multiple server redirects has happened, it is possible to construct the whole redirect chain by repeatedly calling redirectedFrom().
Usage
For example, if the website http://example.com redirects to https://example.com:
const response = await page.goto('http://example.com');
console.log(response.request().redirectedFrom().url()); // 'http://example.com' If the website https://google.com has no redirects:
const response = await page.goto('https://google.com');
console.log(response.request().redirectedFrom()); // null Returns
New request issued by the browser if the server responded with redirect.
Usage
This method is the opposite of request.redirectedFrom():
console.log(request.redirectedFrom().redirectedTo() === request); // true
Returns
Contains the request's resource type as it was perceived by the rendering engine. ResourceType will be one of the following: document, stylesheet, image, media, font, script, texttrack, xhr, fetch, eventsource, websocket, manifest, other.
Usage
request.resourceType();
Returns
Returns the matching Response object, or null if the response was not received due to error.
Usage
await request.response();
Returns
The Service Worker that is performing the request.
Usage
request.serviceWorker();
Returns
Details
This method is Chromium only. It's safe to call when using other browsers, but it will always be null.
Requests originated in a Service Worker do not have a request.frame() available.
Returns resource size information for given request.
Usage
await request.sizes();
Returns
requestBodySize number
Size of the request body (POST data payload) in bytes. Set to 0 if there was no body.
requestHeadersSize number
Total number of bytes from the start of the HTTP request message until (and including) the double CRLF before the body.
responseBodySize number
Size of the received response body (encoded) in bytes.
responseHeadersSize number
Total number of bytes from the start of the HTTP response message until (and including) the double CRLF before the body.
Returns resource timing information for given request. Most of the timing values become available upon the response, responseEnd becomes available when request finishes. Find more information at Resource Timing API.
Usage
const requestFinishedPromise = page.waitForEvent('requestfinished');
await page.goto('http://example.com');
const request = await requestFinishedPromise;
console.log(request.timing()); Returns
startTime number
Request start time in milliseconds elapsed since January 1, 1970 00:00:00 UTC
domainLookupStart number
Time immediately before the browser starts the domain name lookup for the resource. The value is given in milliseconds relative to startTime, -1 if not available.
domainLookupEnd number
Time immediately after the browser starts the domain name lookup for the resource. The value is given in milliseconds relative to startTime, -1 if not available.
connectStart number
Time immediately before the user agent starts establishing the connection to the server to retrieve the resource. The value is given in milliseconds relative to startTime, -1 if not available.
secureConnectionStart number
Time immediately before the browser starts the handshake process to secure the current connection. The value is given in milliseconds relative to startTime, -1 if not available.
connectEnd number
Time immediately before the user agent starts establishing the connection to the server to retrieve the resource. The value is given in milliseconds relative to startTime, -1 if not available.
requestStart number
Time immediately before the browser starts requesting the resource from the server, cache, or local resource. The value is given in milliseconds relative to startTime, -1 if not available.
responseStart number
Time immediately after the browser receives the first byte of the response from the server, cache, or local resource. The value is given in milliseconds relative to startTime, -1 if not available.
responseEnd number
Time immediately after the browser receives the last byte of the resource or immediately before the transport connection is closed, whichever comes first. The value is given in milliseconds relative to startTime, -1 if not available.
URL of the request.
Usage
request.url();
Returns
© 2025 Microsoft
Licensed under the Apache License, Version 2.0.
https://playwright.dev/docs/api/class-request